import Image
import ImageDraw
import math

radialres = 80
ledcount = 15
ledsize =.8 # in mm
wheelradius = 1.1811 #in inches
pi=3.14159
innercirclepercent = 3

def zeros(*shape):
    if len(shape) == 0:
        return 0
    car = shape[0]
    cdr = shape[1:]
    return [zeros(*cdr) for i in range(car)]

def dumbaverage(image,centerx,centery):
    return image.getpixel((int(x),int(y)))
def getaverage(image, step, center, radius,angle, breadth):
    thesum = 0
    count = 1
    
    #print [(step/20)*x for x in range(0,breadth)]
    for i in [(step/20)*x for x in range(0,breadth)]:
        count+=1
        x = math.sin(i+angle)*radius + center
        y = math.cos(i+angle)*radius + center
       
        
        if x>im.size[0] or y>im.size[1]:
            count-=1
        else:
            thesum += image.getpixel((int(x),int(y)))
        count+=1
        x = math.sin(angle-i)*radius + center
        y = math.cos(angle-i)*radius + center
       
        
        if x>im.size[0] or y>im.size[1]:
            count-=1
        else:
            thesum += image.getpixel((int(x),int(y)))
        

    return thesum*1.0/count



im = Image.open("ctlogo.png")

dimensions = im.size
ledsize = int(ledsize*((dimensions[0]/(2*wheelradius*1.0))/25.4))
if dimensions[0]!=dimensions[1]:
    print "Error, image is not square.  Use a square image."
    quit
outercircle = dimensions[1]/2
innercircle = int(outercircle*innercirclepercent/100.0)
center = outercircle
ledspacing = (outercircle-innercircle)/ledcount


inpreview = im.copy()
indraw = ImageDraw.Draw(inpreview)
out = Image.new('P',(radialres+10,ledcount+10),255)
outdraw = ImageDraw.Draw(out)
outy=0
for j in range(innercircle,outercircle,ledspacing):
    
    step = 2*pi/radialres
    outx = 0
    
    for i in [x*step for x in range(0,radialres)]:
        
        x = math.sin(i)*j + center
        y = math.cos(i)*j + center
        #print im.getpixel((int(x),int(y)))[0]
        #print dumbaverage(im,x,y)
        if dumbaverage(im,x,y)>125:
            color = 255
        else:
            color =0
        
        outdraw.point((outx,outy),color)
        #print im.getpixel((int(x),int(y)))
        indraw.point((int(x),int(y)),fill=1)
        outx+=1
    outy+=1

        

outy=0
sim = Image.new('P',(dimensions[0],dimensions[1]),255)
simdraw = ImageDraw.Draw(sim)

#array consists of columns of bytes where 1 byte = 8 LEDs
#rows represent radial direction

outputarray=zeros(radialres*int(math.ceil(ledcount/8.0)))
        
for j in range(innercircle,outercircle,ledspacing):
    step = 2*pi/radialres
    outx = 0
    for i in [x*step for x in range(0,radialres)]:
        x = math.sin(i)*j + center
        y = math.cos(i)*j + center
        nextx = math.sin(i+step)*j+center
        nexty = math.cos(i+step)*j+center
        simdraw.line([(x,y),(nextx,nexty)],out.getpixel((outx,outy)),ledsize)
        if (outy<7):
            if (out.getpixel((outx,outy))==0):
                #print outputarray[outx][0]+2**outy
                outputarray[2*outx]=outputarray[2*outx]+2**(6-outy)
        else:
            if (out.getpixel((outx,outy))==0):
                #print outputarray[outx][0]+2**(outy-8)
                outputarray[2*outx+1]=outputarray[2*outx+1]+2**(7-(outy-7))
        outx+=1
    outy+=1

simdraw.ellipse((0,0,dimensions[0],dimensions[1]),fill=None,outline=120)

simdraw.ellipse(((center-innercircle),(center-innercircle),(center+innercircle),(center+innercircle)),fill=None,outline=120)


#inpreview.show()
#out.show()
print outputarray
sim.show()
